package org.netkernel.layer0.meta.impl;

import javax.xml.parsers.ParserConfigurationException;

import org.netkernel.container.IMessages;
import org.netkernel.layer0.bnf.GrammarParseException;
import org.netkernel.urii.INetKernelException;
import org.w3c.dom.Element;

/** Interface for plugging in new custom grammars. Add impl to MetadataUtils.sCustomGrammarParsersByTag.
 * @author tab
 *
 */
public interface IGrammarParser
{
	 /** Parse grammar defined inside element aGrammarDefn, putting grammar into EndpointMetaBuilder and also declaring metadata for any detected arguments
	 * @param aGrammarDefn
	 * @param aBuilder
	 * @param aMessages
	 * @throws ParserConfigurationException
	 * @throws GrammarParseException
	 * @throws INetKernelException
	 */
	void parseGrammar(Element aGrammarDefn, EndpointMetaBuilder aBuilder, IMessages aMessages) throws ParserConfigurationException, GrammarParseException, INetKernelException;
}
