package org.netkernel.layer0.meta.impl;

import org.netkernel.request.IRequestResponseFields;
import org.netkernel.request.impl.RequestResponseFieldsImpl;
import org.netkernel.urii.IIdentifier;
import org.netkernel.urii.IMetaRepresentation;

public class MetaRepresentationImpl implements IMetaRepresentation
{
	private final String mName;
	private final String mDescription;
	private final IIdentifier mIcon;
	private final IIdentifier mDoc;
	private IRequestResponseFields mAdditionalFields=RequestResponseFieldsImpl.EMPTY;
	
	public MetaRepresentationImpl(String aName, String aDescription, IIdentifier aIcon, IIdentifier aDoc)
	{	mName=aName;
		mDescription=aDescription;
		mIcon=aIcon;
		mDoc=aDoc;
	}
	
	public String getName()
	{	return mName;
	}
	
	public String getDescription()
	{	return mDescription;
	}

	public IIdentifier getIcon()
	{	return mIcon;
	}
	
	public IIdentifier getHumanReadableDocumentation()
	{	return mDoc;
	}

	public IRequestResponseFields getAdditionalFields()
	{	return mAdditionalFields;
	}
	
	
	public void addAdditionalField(String aName, Object aValue)
	{	if (mAdditionalFields==RequestResponseFieldsImpl.EMPTY)
		{	mAdditionalFields = new RequestResponseFieldsImpl(4);
		}
		((RequestResponseFieldsImpl)mAdditionalFields).put(aName, aValue);
	}
	
	public void setAdditionalFields(IRequestResponseFields aFields)
	{	mAdditionalFields=aFields;
	}
}