package org.netkernel.layer0.representation.impl;

import org.netkernel.layer0.representation.IHDSIndexSpecification;
import org.netkernel.layer0.representation.IHDSNode;
import org.netkernel.layer0.representation.IHDSNodeList;
import org.netkernel.layer0.util.HDSUtils;

public class HDSIndexSpecificationFactory
{
	public static final IHDSIndexSpecification INDEX_ALL_BY_VALUE;
	public static final IHDSIndexSpecification INDEX_BY_ID_ATTRIBUTE;
	
	static
	{
		INDEX_ALL_BY_VALUE = new IHDSIndexSpecification()
		{	public Object getKeyValue(IHDSNode aNodeToIndex)
			{	return aNodeToIndex.getValue();
			}

			public IHDSNodeList getNodesToIndex(IHDSNode aContextNode)
			{	return HDSUtils.inOrderTraversal(aContextNode);
			}
		};	
		
		INDEX_BY_ID_ATTRIBUTE = new IHDSIndexSpecification()
		{	public Object getKeyValue(IHDSNode aNodeToIndex)
			{	return aNodeToIndex.getFirstValue("@id");
			}

			public IHDSNodeList getNodesToIndex(IHDSNode aContextNode)
			{	return aContextNode.getNodes("//*").filter(HDSPredicateFactory.hasChild("@id"));
			}
		};	
		
	}
	
}